#-----------------------------------------------------------------------
# Modified 2003 Boris Schfer <menc@noid-project>
# for the Video::Menc project
#-----------------------------------------------------------------------

#-----------------------------------------------------------------------
# Copyright (C) 2001-2002 Jrn Reder <joern@zyn.de> All Rights Reserved
# 
# This module is part of Video::DVDRip, which is free software; you can
# redistribute it and/or modify it under the same terms as Perl itself.
#-----------------------------------------------------------------------

package Video::Menc::GUI::Project;

use Carp;
use strict;

sub gtk_content_clist      { shift->{gtk_content_clist}  }
sub set_gtk_content_clist  { shift->{gtk_content_clist}  = $_[1] }

sub clist_row2title_nr     { shift->{clist_row2title_nr} }  # href
sub set_clist_row2title_nr { shift->{clist_row2title_nr} = $_[1] }

sub gtk_audio_popup        { shift->{gtk_audio_popup}    }  # lref
sub set_gtk_audio_popup    { shift->{gtk_audio_popup}    = $_[1] }
sub gtk_audio_popup_2      { shift->{gtk_audio_popup_2}  }  # lref
sub set_gtk_audio_popup_2  { shift->{gtk_audio_popup_2}  = $_[1] }
sub gtk_sub_popup          { shift->{gtk_sub_popup}      }  # lref
sub set_gtk_sub_popup      { shift->{gtk_sub_popup}      = $_[1] }

#------------------------------------------------------------------------
# Build RIP Title Tab
#------------------------------------------------------------------------

sub create_title_tab {
  my $self = shift; $self->trace_in;

  my $vbox = Gtk::VBox->new;
  $vbox->set_border_width(5);
  $vbox->show;
  
  my $frame = Gtk::Frame->new ("DVD");
  $frame->show;

  my $hbox = Gtk::HBox->new;
  $hbox->set_border_width(5);
  $hbox->show;
  $frame->add ( $hbox );

  my $list_vbox = Gtk::VBox->new;
  $list_vbox->show;
  $hbox->pack_start ( $list_vbox, 0, 1, 0);

  my $clist = Gtk::CList->new_with_titles (
    "  Title  ", "  Length                   ", "  Additional Information  "
  );
  $clist->show,
  $clist->set_usize (500, 450);
  $clist->set_selection_mode( 'browse' ); 
  $clist->signal_connect ("select_row", sub { $self->cb_select_title (@_) } );
  $self->set_gtk_content_clist ($clist);
  
  $list_vbox->pack_start ( $clist, 0, 1, 0);

  # 3. Audio Selection Popup
  my $audio_vbox = Gtk::VBox->new;
  $audio_vbox->show;
  $hbox->pack_start ($audio_vbox, 0, 1, 0);

  my $button;  
  $button = Gtk::Button->new_with_label (" Read TOC ");
  $button->show;
  $audio_vbox->pack_start($button, 0, 1, 0);
  $button->signal_connect ("clicked",
    sub { $self->read_dvd_toc }
  );  
  
  $button = Gtk::Button->new_with_label (" View Selected Title ");
  $button->show;
  $audio_vbox->pack_start($button, 0, 1, 0);
  $button->signal_connect ("clicked",
    sub { $self->view_title }
  );  
  my $label_hbox = Gtk::HBox->new;
  $label_hbox->show;
  
  $button = Gtk::Button->new_with_label (" View Selected Title (2nd Audio)");
  $button->show;
  $audio_vbox->pack_start($button, 0, 1, 0);
  $button->signal_connect ("clicked",
    sub { $self->view_title2 }
  );  
  my $label_hbox = Gtk::HBox->new;
  $label_hbox->show;  

  my $label = Gtk::Label->new ("Select Audio Channel                       ");
  $label->show;
  $label->set_justify('left');
  $label_hbox->pack_start ($label, 0, 1, 0);
  $audio_vbox->pack_start ($label_hbox, 0, 1, 0);
  
  my $audio_popup_menu = Gtk::Menu->new;
  $audio_popup_menu->show;
  my $item = Gtk::MenuItem->new ("No Audio");
  $item->show;
  $audio_popup_menu->append($item);
  my $audio_popup = Gtk::OptionMenu->new;
  $audio_popup->show;
  $audio_popup->set_menu($audio_popup_menu);
  $audio_popup->set_usize(200,undef);
  
  $self->set_gtk_audio_popup ($audio_popup);
  $audio_vbox->pack_start($audio_popup, 0, 1, 0);

  $label_hbox = Gtk::HBox->new;
  $label_hbox->show;
  
  $label = Gtk::Label->new ("Select 2nd Audio Channel");
  $label->show;
  $label->set_justify('left');
  $label_hbox->pack_start ($label, 0, 1, 0);
  $audio_vbox->pack_start ($label_hbox, 0, 1, 0);
  
  $audio_popup_menu = Gtk::Menu->new;
  $audio_popup_menu->show;
  $item = Gtk::MenuItem->new ("No Audio");
  $item->show;
  $audio_popup_menu->append($item);
  $audio_popup = Gtk::OptionMenu->new;
  $audio_popup->show;
  $audio_popup->set_menu($audio_popup_menu);
  $audio_popup->set_usize(200,undef);
  
  $self->set_gtk_audio_popup_2 ($audio_popup);
  $audio_vbox->pack_start($audio_popup, 0, 1, 0);

  $label_hbox = Gtk::HBox->new;
  $label_hbox->show;
  
  $label = Gtk::Label->new ("Select Subtitle");
  $label->show;
  $label->set_justify('left');
  $label_hbox->pack_start ($label, 0, 1, 0);
  $audio_vbox->pack_start ($label_hbox, 0, 1, 0);
  
  $audio_popup_menu = Gtk::Menu->new;
  $audio_popup_menu->show;
  $item = Gtk::MenuItem->new ("No Subtitle");
  $item->show;
  $audio_popup_menu->append($item);
  $audio_popup = Gtk::OptionMenu->new;
  $audio_popup->show;
  $audio_popup->set_menu($audio_popup_menu);
  $audio_popup->set_usize(200,undef);
  
  $self->set_gtk_sub_popup ($audio_popup);
  $audio_vbox->pack_start($audio_popup, 0, 1, 0);

  # DVD-Device
  $label_hbox = Gtk::HBox->new;
  $label_hbox->show;
  
  $label = Gtk::Label->new ("DVD-Device");
  $label->show;
  $label->set_justify('left');
  $label_hbox->pack_start ($label, 0, 1, 0);
  $audio_vbox->pack_start ($label_hbox, 0, 1, 0);
  
  my $dvd_hbox = Gtk::HBox->new;
  $dvd_hbox->set_border_width(5);
  $dvd_hbox->show;
  $audio_vbox->pack_start($dvd_hbox, 0, 1, 0);
    
  my $entry = Gtk::Entry->new;
  $entry->set_text ("");
  $entry->set_usize(120, undef);
  $entry->show;
  $entry->signal_connect ("changed",
    sub { $self->use_dvddevice }
  );
  $self->adjust_widgets->{dvddevice} = $entry;
  $dvd_hbox->pack_start($entry, 0, 1, 0);
  
  my $button = Gtk::Button->new_with_label (" Browse... ");
  $button->show;
  $dvd_hbox->pack_end ($button, 1, 1, 0);
  $button->signal_connect ("clicked",
    sub { $self->browse_dvddevice }
  );
  
  # 6. Fill Content List, if we have content
  $self->fill_content_list;
        $vbox->pack_start ( $frame, 0, 1, 0);
    
  return $vbox;
}

sub cb_select_title {
  my $self = shift; $self->trace_in;
  my ($clist, $row, $column, $event) = @_;

  my $nr = $self->clist_row2title_nr->{$row};
  $self->project->set_selected_title_nr ($nr);
  $self->set_selected_title($self->project->content->titles->{$nr});
  
  $self->fill_with_values;
  
  1;
}

sub init_audio_popup {
  my $self = shift; $self->trace_in;

  my $title = $self->selected_title;
  
  return if not $title;

  if ( $title->type eq "dvd" ) {
    my $audio_popup = $self->gtk_audio_popup;
    my $audio_popup2 = $self->gtk_audio_popup_2;
  
    my $audio_popup_menu = Gtk::Menu->new;
    $audio_popup_menu->show;
    $audio_popup->set_menu($audio_popup_menu);
    
    my $audio_popup_menu2 = Gtk::Menu->new;
    $audio_popup_menu2->show;
    $audio_popup2->set_menu($audio_popup_menu2);

    my $item = Gtk::MenuItem->new ("No Audio");
    $item->show;
    $item->signal_connect ("select", sub {
      $title->set_audio_channel(-1);
      $self->init_title_labels;
      $self->init_mencoder_values;
    } );
    $audio_popup_menu->append($item);
    
    my $item2 = Gtk::MenuItem->new ("No Audio");
    $item2->show;
    $item2->signal_connect ("select", sub {
      $title->set_audio2_channel(-1);
      $self->init_title_labels;
      $self->init_mencoder_values;
    } );
    $audio_popup_menu2->append($item2);    

    my $i = 0;
    foreach my $audio ( @{$title->audio_tracks} ) {
      my $bitrate = $audio->{bitrate};
      $bitrate = $bitrate/1000 if ($bitrate);
      $bitrate = " ($bitrate kbits/s)" if ($bitrate);
    
      $item = Gtk::MenuItem->new (
        "$i: $audio->{lang} $audio->{format}".
        "$bitrate"
      );
      $item->show;
      $item->signal_connect (
        "select", sub {
          $_[1]->set_audio_channel($_[2]);
          $self->init_title_labels;
          $self->init_mencoder_values;
        },
        $title, $i
      );
      $audio_popup_menu->append($item);
      
      $item2 = Gtk::MenuItem->new (
        "$i: $audio->{lang} $audio->{format}".
        "$bitrate"
      );
      $item2->show;
      $item2->signal_connect (
        "select", sub {
          $_[1]->set_audio2_channel($_[2]);
          $self->init_title_labels;
          $self->init_mencoder_values;
        },
        $title, $i
      );
      $audio_popup_menu2->append($item2);      
      
      ++$i;
    }
    
    if ($title->audio_channel == -1) {
      $title->set_audio_channel(0) if ($title->audio_tracks);
    }
    
    $audio_popup->set_history($title->audio_channel+1);
    $audio_popup2->set_history($title->audio2_channel+1);
  }
  
  1;
}

sub init_sub_popup {
  my $self = shift; $self->trace_in;

  my $title = $self->selected_title;
  
  return if not $title;

  if ( $title->type eq "dvd" ) {
    my $sub_popup = $self->gtk_sub_popup;
  
    my $sub_popup_menu = Gtk::Menu->new;
    $sub_popup_menu->show;
    $sub_popup->set_menu($sub_popup_menu);
    
    my $item = Gtk::MenuItem->new ("No Subtitle");
    $item->show;
    $item->signal_connect ("select", sub {
      $title->set_subtitle(-1);
      $self->init_title_labels;
      $self->init_mencoder_values;
    } );
    $sub_popup_menu->append($item);
    
    if ($title->subtitles) {
      my $i = 0;
      foreach my $sub ( @{$title->subtitles} ) {
        $item = Gtk::MenuItem->new (
          "$i: $sub->{lang}"
        );
        $item->show;
        $item->signal_connect (
          "select", sub {
            $title->set_subtitle($_[1]);
            $self->init_title_labels;
            $self->init_mencoder_values;
          },
          $i
        );
        $sub_popup_menu->append($item);
      
        ++$i;
      }
    }
    
    $sub_popup->set_history($title->subtitle+1);
  }
  
  1;
}

sub read_dvd_toc {
  my $self = shift; $self->trace_in;

  return if $self->comp('progress')->is_active;

  my $project = $self->project;
  my $content = $project->content;

  $self->clear_content_list;

  my $fh = $content->dvd_content_async_start (
    dvdtrack => 1
  );

  $self->comp('progress')->open_continious_progress (
    max_value => 1,
    label     => "Reading Title Listing",
    fh        => $fh,
    need_output => 1,
    get_progress_callback => sub {
      my %par = @_;
      my ($buffer) = @par{'buffer'};
      return $buffer;
    },
    finished_callback => sub {
      my %par = @_;
      my  ($output) = @par{'output'};
      
      $content->dvd_content_async_stop ( 
        fh => $fh,
        output => $output,
        dvdtrack => 1,
      );
      
      $self->read_dvd_toc_part2;
    },
    cancel_callback => sub {
      close $fh;
    },
  );
  
  1;
}

sub read_dvd_toc_part2 {  
  my $self = shift; $self->trace_in;

  return if $self->comp('progress')->is_active;

  my $project = $self->project;
  my $content = $project->content;

  $content->set_titles(undef); 
  my $titles = $content->get_titles;

  $self->comp('progress')->open_steps_progress (
    title => "Read DVD TOC",
    steps => scalar(@{$titles}),
    label => "Probing Track #",
    need_output => 1,
    open_next_step_callback => sub {
      my %par = @_;
      my ($step) = @par{'step'};
      my $dvdtrack = $step+1;#$titles->[$step]->dvdtrack;
      return $content->dvd_content_async_start (
        dvdtrack => $dvdtrack,
      );
    },
    close_step_callback => sub {
      my %par = @_;
      my  ($step, $fh, $output) =
      @par{'step','fh','output'};
      my $dvdtrack = $step+1;#$titles->[$step]->dvdtrack;
      eval {
        $content->dvd_content_async_stop (
          fh     => $fh,
          output => $output,
          dvdtrack => $dvdtrack
        );
      };
      if ( not $@ ) {
        
        $titles->[$step]->set_width ( $content->probe_result->width );
        $titles->[$step]->set_height ( $content->probe_result->height );
        $titles->[$step]->set_fps ( $content->probe_result->fps );
        $titles->[$step]->set_aspect ( $content->probe_result->aspect );
        $titles->[$step]->set_runtime ( $content->probe_result->runtime );
        $titles->[$step]->set_audio_tracks ( $content->probe_result->audio_tracks );
	$titles->[$step]->set_subtitles ( $content->probe_result->subtitles );
        
        if ( @{$titles->[$step]->audio_tracks} >= 1 )
        {
          @{$titles->[$step]->audio_tracks}[0]->{bitrate} = 
            $content->probe_result->abitrate;
        }
        $titles->[$step]->set_audio_channel(-1);
        $titles->[$step]->set_audio2_channel(-1);
        
        $self->append_content_list ( title => $titles->[$step] );
      } else {
        $self->message_window (
          message => "Can't probe Track #$step\n\n".
               "Track will not be listed.\n\n".
               "Output was:\n\n$output\n\n$@"
        );
      }
    },
    finished_callback => sub {
      my $nr = $self->clist_row2title_nr->{0};
      $self->project->set_selected_title_nr ($nr);
      my $title = $self->project->content->titles->{$nr};
      $self->set_selected_title( $title );
      $self->fill_with_values;
      
      $self->read_dvd_toc_part3;
    }
  );

  1;
}

sub read_dvd_toc_part3 {  
  my $self = shift; $self->trace_in;

  return if $self->comp('progress')->is_active;

  my $project = $self->project;
  my $content = $project->content;

  my $titles = $content->get_titles;
  my $i = 0;
  
  my (@probe_audio);
  foreach my $title ( @{$titles} ) {
    my $audios = @{$title->audio_tracks};
    
    if ( $audios > 1 ) {
      for (my $j=1; $j<$audios; $j++) {
        my $audio = $title->audio_tracks->[$j];

        $probe_audio[$i] = {
          dvdtrack   => $title->{dvdtrack},
          audiotrack => $j, 
          audioid    => $audio->{id}
        };
        $i++;        
      }
    }
  }    
  
  if ( @probe_audio ) {
    $self->comp('progress')->open_steps_progress (
      title => "Read DVD Audiotracks",
      steps => scalar(@probe_audio),
      label => "Probing Audiotrack #",
      need_output => 1,
      open_next_step_callback => sub {
        my %par = @_;
        my ($step) = @par{'step'};

        my $dvdtrack = @probe_audio[$step]->{dvdtrack};
        my $audiotrack = @probe_audio[$step]->{audiotrack};
        my $audioid = @probe_audio[$step]->{audioid};
      
        return $content->dvd_content_async_start (
          dvdtrack => $dvdtrack,
          audioid  => $audioid,
          notcprobe => 1,
        );
      },
      close_step_callback => sub {
        my %par = @_;
        my  ($step, $fh, $output) =
        @par{'step','fh','output'};

        my $dvdtrack = @probe_audio[$step]->{dvdtrack};
        my $audiotrack = @probe_audio[$step]->{audiotrack};
        my $audioid = @probe_audio[$step]->{audioid};
              
        eval {
          $content->dvd_content_async_stop (
            fh     => $fh,
            output => $output,
            dvdtrack => $dvdtrack,
            audioid  => $audioid,
            notcprobe => 1,
          );
        };
        if ( not $@ ) {
        
          @{$titles->[$dvdtrack-1]->audio_tracks}[$audiotrack]->{bitrate} =
            $content->probe_result->abitrate;

        } else {
          $self->message_window (
            message => "Can't probe Track #$step\n\n".
                 "Track will not be listed.\n\n".
                 "Output was:\n\n$output\n\n$@"
          );
        }
      },
      finished_callback => sub {
        my $nr = $self->clist_row2title_nr->{0};
        $self->project->set_selected_title_nr ($nr);
        my $title = $self->project->content->titles->{$nr};
        $self->set_selected_title( $title );
        $self->fill_with_values;
      }
    );
  }

  1;
}

sub clear_content_list {
  my $self = shift; $self->trace_in;

  $self->gtk_content_clist->clear;
  $self->set_clist_row2title_nr({});
  1;
}

sub fill_content_list {
  my $self = shift; $self->trace_in;
  
  return if not $self->project->content->titles;

  my $titles = $self->project->content->get_titles_by_size;
  
  $self->clear_content_list;
  
  my $row = 0;
  my $select_row;
  my $selected_title_nr = $self->project->selected_title_nr;

  foreach my $title ( @{$titles} ) {
    next if not defined $title->probe_result;
    $self->append_content_list ( title => $title );
    $select_row = $row if $selected_title_nr == $title->dvdtrack;
    ++$row;
  }
  
  $self->gtk_content_clist->select_row ($select_row, 1);

  1;
}

sub append_content_list {
  my $self = shift; $self->trace_in;
  my %par = @_;
  my ($title) = @par{'title'};

  my $length = $title->runtime-1;
  my $h = int($length/3600);
  my $m = int(($length-$h*3600)/60);
  my $s = $length-$h*3600-$m*60;
  my $length2 = sprintf ("%02d:%02d:%02d", $h, $m, $s);

  my $row = $self->gtk_content_clist->append (
    $title->dvdtrack,
    $length."sec (".$length2.")",
    $self->get_title_info ( title => $title ),
  );
  
  $self->clist_row2title_nr->{$row} = $title->dvdtrack;
}

sub view_title {
  my $self = shift;
  
  my $titlenr = $self->project->selected_title_nr;
  my $title = $self->project->content->titles->{$titlenr};  

  return if not $title;

  my $sub = "-sid ".$title->subtitle;
  $sub = "" if ($title->subtitle == -1);

  my $command = $title->precmd." mplayer -osdlevel 3 ".
                $title->audiocmd." ".$sub." ".$title->postcmd." &";

  system ($command);
  
  1;
}

sub view_title2 {
  my $self = shift;
  
  my $titlenr = $self->project->selected_title_nr;
  my $title = $self->project->content->titles->{$titlenr};  

  return if not $title;

  my $sub = "-sid ".$title->subtitle;
  $sub = "" if ($title->subtitle == -1);
  
  my $command = $title->precmd." mplayer -osdlevel 3 ".
                $title->audiocmd2." ".$sub." ".$title->postcmd." &";

  system ($command);
  
  1;
}

sub use_dvddevice {
  my $self = shift;
  my $widgets = $self->adjust_widgets;
  
  my $filename = $widgets->{dvddevice}->get_text;      
  $filename =~ s/^\s+//;
  $filename =~ s/\s+$//;      
  $self->project->set_dvd_device($filename) if ($filename ne "");
  $self->project->set_dvd_device($self->project->dvddevice) if ($filename eq "");
}

sub browse_dvddevice {
  my $self = shift;
  my $widgets = $self->adjust_widgets;

  my $filename = $widgets->{dvddevice}->get_text;
  $filename =~ s/^\s+//;
  $filename =~ s/\s+$//;
  
  $self->show_file_dialog (
    dir      => ".",
    filename => "$filename",
    cb       => sub {
      my $filename = $_[0];
      $filename =~ s/^\s+//;
      $filename =~ s/\s+$//;      
      $widgets->{dvddevice}->set_text ( $filename );
                  $self->project->set_dvd_device($filename) if ($filename ne "");
      $self->project->set_dvd_device($self->project->dvddevice) if ($filename eq "");
    },
  );
}

1;
